//+------------------------------------------------------------------+
//|                                                 ZeroLag MACD.mq4 |
//|                                                               RD |
//|                                                 marynarz15@wp.pl |
//+------------------------------------------------------------------+
#property copyright "RD"
#property link      "marynarz15@wp.pl"

#property indicator_separate_window
#property indicator_buffers  2
#property indicator_level1   0.0
#property indicator_color1   Magenta
#property indicator_color2   Orange
//---- input parameters
extern int       FastEMA   = 12;
extern int       SlowEMA   = 24;
extern int       SignalEMA = 9;
//---- buffers
double MACDBuffer[], SignalBuffer[], FastEMABuffer[],
       SlowEMABuffer[], SignalEMABuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
//---- indicators
    IndicatorBuffers (5);
    SetIndexBuffer (0, MACDBuffer);
    SetIndexStyle (0, DRAW_HISTOGRAM, EMPTY, 2);
    SetIndexLabel (0, "MACD");
    SetIndexBuffer (1, SignalBuffer);
    SetIndexStyle (1, DRAW_LINE, EMPTY, 2);
    SetIndexLabel (1, "Signal");
    SetIndexBuffer (2, FastEMABuffer);
    SetIndexBuffer (3, SlowEMABuffer);
    SetIndexBuffer (4, SignalEMABuffer);
    SetIndexDrawBegin (0, SlowEMA);
    SetIndexDrawBegin (1, SlowEMA);
    IndicatorShortName ("ZeroLag MACD(" + (string) FastEMA + "," + (string) SlowEMA + "," + (string) SignalEMA + ")");
//----
    return (INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit (const int reason)
{
//----
    
//----
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (
    const int rates_total,
    const int prev_calculated,
    const datetime &time[],
    const double &open[],
    const double &high[],
    const double &low[],
    const double &close[],
    const long &tick_volume[],
    const long &volume[],
    const int &spread[])
{
    int counted_bars = prev_calculated;
//---
    if (prev_calculated < 0) return (-1);
    double EMA, ZeroLagEMAp, ZeroLagEMAq;
    int    i, limit;
    if (prev_calculated > 0)
    {
        counted_bars--;
        limit = rates_total - counted_bars;
    }
    else limit = rates_total - 1;
    for (i = limit; i >= 0; i--)
    {
        FastEMABuffer[i] = iMA (NULL, 0, FastEMA, 0, MODE_EMA, PRICE_CLOSE, i);
        SlowEMABuffer[i] = iMA (NULL, 0, SlowEMA, 0, MODE_EMA, PRICE_CLOSE, i);
    }
    for (i = 0; i < limit; i++)
    {
        EMA = iMAOnArray (FastEMABuffer, rates_total, FastEMA, 0, MODE_EMA, i);
        ZeroLagEMAp = FastEMABuffer[i] + FastEMABuffer[i] - EMA;
        EMA = iMAOnArray (SlowEMABuffer, rates_total, SlowEMA, 0, MODE_EMA, i);
        ZeroLagEMAq = SlowEMABuffer[i] + SlowEMABuffer[i] - EMA;
        MACDBuffer[i]= ZeroLagEMAp - ZeroLagEMAq;
    }
    for (i = 0; i < limit; i++)
    {SignalEMABuffer[i] = iMAOnArray (MACDBuffer, rates_total, SignalEMA, 0, MODE_EMA, i);}
    for (i = 0; i < limit; i++)
    {
        EMA = iMAOnArray (SignalEMABuffer, rates_total, SignalEMA, 0, MODE_EMA, i);
        SignalBuffer[i] = SignalEMABuffer[i] + SignalEMABuffer[i] - EMA;
    }
    return (rates_total);
}
//+------------------------------------------------------------------+